<?php
  /**
   * Main
   *
   * @package CMS Pro
   * @author wojoscripts.com
   * @copyright 2010
   * @version $Id: main.php, v2.00 2011-04-20 10:12:05 gewa Exp $
   */
  if (!defined("_VALID_PHP"))
      die('Direct access to this location is not allowed.');
?>
<div class="block-top-header">
  <h1><img src="images/home-sml.png" alt="" /><?php echo _MN_TITLE;?></h1>
  <div class="divider"><span></span></div>
</div>
<p class="info"><span><?php echo $core->langIcon();?></span><?php echo _MN_INFO;?></p>
<div class="block-border">
  <div class="block-header">
    <h2><?php echo _MN_SUBTITLE;?></h2>
  </div>
  <div class="block-content">
    <?php $monthly = $core->monthlyStats();?>
    <?php $stats = $core->getStats();?>
    <script type="text/javascript" src="assets/jquery.jqplot.min.js"></script> 
    <script type="text/javascript" src="assets/jqplot.barRenderer.min.js"></script> 
    <script type="text/javascript" src="assets/jqplot.categoryAxisRenderer.min.js"></script> 
    <script type="text/javascript" src="assets/jqplot.pointLabels.min.js"></script> 
    <!--[if lt IE 9]><script type="text/javascript" src="assets/excanvas.min.js"></script><![endif]-->
    <?php if($monthly):?>
    <script type="text/javascript">
  $(document).ready(function(){
    var s1 = [
	<?php
		$res = '';
		foreach($stats as $row) {
			if(strlen($res) > 0) {
				$res .= ",";
			}
			$res .= $row['views'];
		}
		echo $res;
		?>
	];
    var s2 = [
	<?php
		$res2 = '';
		foreach($stats as $row) {
			if(strlen($res2) > 0) {
				$res2 .= ",";
			}
			$res2 .= $row['visits'];
		}
		echo $res2;
		?>
	];
    var ticks = [
	<?php
		$res3 = '';
		$i=0;
		foreach($stats as $rep) {
			$i++;
			if(strlen($res3) > 0) {
				$res3 .= ",";
			}
			$res3 .= $i;
		}
		?>
		<?php print $res3;?>
	];
    <?php unset($res, $res2, $res3);?>
    plot1 = $.jqplot('chart', [s1, s2], {
	  seriesDefaults: {
	  renderer: $.jqplot.BarRenderer,
	  pointLabels:{show:true}
		  },
	  title: '<?php echo _MN_M_STATS_FOR.' &rsaquo; '.doDate('%b',date("M", mktime(0, 0, 0, $core->month, 10))).' / '.$core->year;?>',
      series:[
        {label:'<?php echo _MN_TOTAL_H;?>'},
        {label:'<?php echo _MN_UNIQUE_V;?>'}
      ],
      legend: {
        show: true,
		location: 'ne'
      },
      axes: {
        xaxis: {
          renderer: $.jqplot.CategoryAxisRenderer,
          ticks: ticks
        }
      }
    });
  });
</script>
    <div class="utility">
      <div id="chart"></div>
    </div>
    <?php endif;?>
    <table class="forms">
      <tfoot>
        <tr>
          <td><a href="javascript:void(0)" class="button-orange delete"><?php echo _MN_EMPTY_STATS;?></a></td>
          <td class="right"><form method="get" action="#" name="admin_form">
          <div class="mybox">
              <select name="month" class="custombox" style="width:120px">
                <?php echo $core->monthList();?>
              </select>
              </div>
               <div class="mybox">
              <select name="year" class="custombox" style="width:70px">
                <?php echo $core->yearList(2009, strftime('%Y')); ?>
              </select>
              </div>
              <input name="submit" value="<?php echo _SUBMIT;?>" type="submit" class="button-blue"/>
            </form></td>
        </tr>
      </tfoot>
      <?php if(!$monthly):?>
      <tr>
        <td colspan="2"><div class="msgAlert"><?php echo _MN_NOSTATS;?></div></td>
      </tr>
      <?php else:?>
      <tr>
        <th><?php echo _MN_TOTAL_V;?></th>
        <td><?php echo ($monthly['total'] + $monthly['visits']);?></td>
      </tr>
      <tr>
        <th><?php echo _MN_TOTAL_H;?></th>
        <td><?php echo $monthly['views'];?></td>
      </tr>
      <tr>
        <th><?php echo _MN_UNIQUE_V;?></th>
        <td><?php echo $monthly['visits'];?></td>
      </tr>
      <?php endif;?>
    </table>
  </div>
</div>

<script type="text/javascript"> 
// <![CDATA[
$(document).ready(function () {
  $('.container').on('click', 'a.delete', function () {
	  var text = '<div><span class="ui-icon ui-icon-alert" style="float:left; margin:0 7px 20px 0;"></span><?php echo _DEL_CONFIRM;?></div>';
	  $.confirm({
		  title: '<?php echo _MN_EMPTY_STATS;?>',
		  message: text,
		  buttons: {
			  '<?php echo _DELETE;?>': {
				  'class': 'yes',
				  'action': function () {
					  $.ajax({
						  type: 'post',
						  url: 'ajax.php',
						  data: 'deleteStats=1',
						  success: function (msg) {
							$('body').fadeOut(1200, function () {
								window.location.href = "index.php";
							});
						  }
					  });
				  }
			  },
			  '<?php echo _CANCEL;?>': {
				  'class': 'no',
				  'action': function () {}
			  }
		  }
	  });
  });
});
// ]]>
</script>