<?php
  /**
   * Transactions
   *
   * @package CMS Pro
   * @author wojoscripts.com
   * @copyright 2010
   * @version $Id: transactions.php, v2.00 2011-04-20 10:12:05 gewa Exp $
   */
  if (!defined("_VALID_PHP"))
      die('Direct access to this location is not allowed.');
	  
  if(!$user->getAcl("Transactions")): print $core->msgAlert(_CG_ONLYADMIN, false); return; endif;
?>
<?php switch($core->action): case "salesyear": ?>
<div class="block-top-header">
  <h1><img src="images/trans-sml.png" alt="" /><?php echo _TR_TITLE2;?></h1>
  <div class="divider"><span></span></div>
</div>
<p class="info"><span><?php echo $core->langIcon();?></span><?php echo _TR_INFO2;?></p>
<div class="block-border">
  <div class="block-header">
    <h2><span><a href="index.php?do=transactions&amp;action=salesmonth"><img src="images/monthly_cal.png" alt="" title="<?php echo _TR_MONTHVIEW;?>" class="tooltip" /></a></span><?php echo _TR_SUBTITLE2.' &rsaquo; '._TR_SALES3.' &rsaquo; '.$core->year;;?></h2>
  </div>
  <div class="block-content">
    <?php $reports = $member->yearlyStats();?>
    <?php $row = $member->getYearlySummary();?>
    <?php if($reports != 0):?>
    <script type="text/javascript" src="assets/jquery.jqplot.min.js"></script> 
    <script type="text/javascript" src="assets/jqplot.barRenderer.min.js"></script> 
    <script type="text/javascript" src="assets/jqplot.categoryAxisRenderer.min.js"></script> 
    <script type="text/javascript" src="assets/jqplot.pointLabels.min.js"></script> 
    <!--[if lt IE 9]><script type="text/javascript" src="assets/excanvas.min.js"></script><![endif]--> 
    <script type="text/javascript">
  $(document).ready(function(){
    var s1 = [
	<?php
		$res = '';
		foreach($reports as $report) {
			if(strlen($res) > 0) {
				$res .= ",";
			}
			$res .= $report['total'];
		}
		echo $res;
		?>
	];
    var s2 = [
	<?php
		$res2 = '';
		foreach($reports as $report) {
			if(strlen($res2) > 0) {
				$res2 .= ",";
			}
			$res2 .= $report['totalprice'];
		}
		echo $res2;
		?>
	];
    var ticks = [
	<?php
		$res3 = '';
		foreach($reports as $rep) {
			if(strlen($res3) > 0) {
				$res3 .= "','";
			}
			$res3 .= date("M", mktime(0, 0, 0, $rep['month'], 10));
		}
		?>
		'<?php print $res3;?>'
	];
    <?php unset($res, $res2, $res3);?>
    plot1 = $.jqplot('chart', [s1, s2], {
      seriesDefaults:{
        renderer:$.jqplot.BarRenderer,
        rendererOptions: {fillToZero: true},
		pointLabels: {show: true}
      },
	  title: '<?php echo _TR_SALES3.' › '.$core->year;?>',
      series:[
        {label:'<?php echo _TR_TOTSALES;?>'},
        {label:'<?php echo _TR_TOTREV;?>'}
      ],
      legend: {
        show: true,
		placement:'outsideGrid',
		location: 'ne'
      },
      axes: {
        xaxis: {
          renderer: $.jqplot.CategoryAxisRenderer,
          ticks: ticks
        },
        yaxis: {
			tickOptions:{
            formatString:'$%.2f'
            },
          autoscale: true
        }
      }
    });
  });
</script>
    <?php endif;?>
    <?php if($reports == 0):?>
    <?php echo $core->msgAlert(_TR_NOYEARSALES,false);?>
    <?php else:?>
    <div class="utility">
      <div id="chart"></div>
    </div>
    <table class="display">
      <thead>
        <tr>
          <th class="left"><?php echo _TR_MONTHYEAR;?></th>
          <th><?php echo _TR_TOTSALES;?></th>
          <th><?php echo _TR_TOTREV;?></th>
        </tr>
      </thead>
      <?php foreach($reports as $report):?>
      <tr>
        <td><?php echo date("M", mktime(0, 0, 0, $report['month'], 10));?> / <?php echo $core->year;?></td>
        <td class="center"><?php echo $report['total'];?></td>
        <td class="center"><?php echo $core->formatMoney($report['totalprice']);?></td>
      </tr>
      <?php endforeach ?>
      <?php unset($report);?>
      <tr>
        <td><strong><?php echo _TR_TOTALYEAR;?></strong></td>
        <td class="center"><strong><?php echo $row['total'];?></strong></td>
        <td class="center"><strong><?php echo $core->formatMoney($row['totalprice']);?></strong></td>
      </tr>
    </table>
    <?php endif;?>
    <div class="box" style="text-align:right">
      <form method="get" action="#" name="date">
        <div class="mybox">
          <select name="year" class="custombox" style="width:80px">
            <?php echo $core->yearList(2010, strftime('%Y')); ?>
          </select>
        </div>
        <input name="submit" value="<?php echo _SUBMIT;?>" type="submit" class="button-blue"/>
        <input name="do" type="hidden" value="transactions" />
        <input name="action" type="hidden" value="salesyear" />
      </form>
    </div>
  </div>
</div>
<?php break;?>
<?php case"salesmonth": ?>
<?php $month_name = date("M", mktime(0, 0, 0, $core->month, 10));?>
<div class="block-top-header">
  <h1><img src="images/trans-sml.png" alt="" /><?php echo _TR_TITLE2;?></h1>
  <div class="divider"><span></span></div>
</div>
<p class="info"><span><?php echo $core->langIcon();?></span><?php echo _TR_INFO2;?></p>
<div class="block-border">
  <div class="block-header">
    <h2><span><a href="index.php?do=transactions&amp;action=salesyear"> <img src="images/yearly_cal.png" alt="" title="<?php echo _TR_YEARVIEW;?>" class="tooltip" /></a></span><?php echo _TR_SUBTITLE2.' &rsaquo; '. _TR_MONTHSALES3 . $month_name.' / '.$core->year;;?></h2>
  </div>
  <div class="block-content">
    <div class="box">
      <form method="get" action="#" name="admin_form">
        <div class="mybox">
          <select name="month" class="custombox">
            <?php echo $core->monthList();?>
          </select>
        </div>
        <div class="mybox">
          <select name="year" class="custombox" style="width:80px">
            <?php echo $core->yearList(2009, strftime('%Y')); ?>
          </select>
        </div>
        <input name="submit" value="<?php echo _SUBMIT;?>" type="submit" class="button-blue"/>
        <input name="do" type="hidden" value="transactions" />
        <input name="action" type="hidden" value="salesmonth" />
      </form>
    </div>
    <?php $monthly = $member->monthlyStats();?>
    <?php if($monthly != 0):?>
    <script type="text/javascript" src="assets/jquery.jqplot.min.js"></script> 
    <script type="text/javascript" src="assets/jqplot.barRenderer.min.js"></script> 
    <script type="text/javascript" src="assets/jqplot.categoryAxisRenderer.min.js"></script> 
    <script type="text/javascript" src="assets/jqplot.pointLabels.min.js"></script> 
    <script type="text/javascript">
  $(document).ready(function(){
    var s1 = [<?php echo $monthly['total'].','.$monthly['totalprice'].','.$monthly['totalprice']/$monthly['total'];?>];
    var ticks = ['<?php echo _TR_TOTSALES;?>','<?php echo _TR_TOTREV;?>','<?php echo _TR_AVERAGE;?>'];
    plot1 = $.jqplot('chart', [s1], {
      seriesDefaults:{
        renderer:$.jqplot.BarRenderer,
        rendererOptions: {fillToZero: true},
		pointLabels: {show: true}
      },
	  title: '<?php echo _TR_MONTHSALES3 . $month_name.' / '.$core->year;?>',
      series:[
        {label:'<?php echo $month_name;?> / <?php echo $core->year;?>'}
      ],
      legend: {
        show: true,
		location: 'ne',
        placement: 'outsideGrid'
      },
      axes: {
        xaxis: {
          renderer: $.jqplot.CategoryAxisRenderer,
          ticks: ticks
        },
        yaxis: {
			tickOptions:{
            formatString:'$%.2f'
            },
          autoscale: true
        }
      }
    });
  });
</script>
    <?php endif;?>
    <?php if($monthly == 0):?>
    <?php echo $core->msgAlert(_TR_NOMONTHSALES,false);?>
    <?php else:?>
    <div class="utility">
      <div id="chart"></div>
    </div>
    <table class="forms">
      <thead>
        <tr>
          <th colspan="2" class="left"><?php echo _TR_MONTHSTATS;?></th>
        </tr>
      </thead>
      <tr>
        <th><?php echo _TR_TOTSALES;?></th>
        <td><?php echo $monthly['total'] . _TR_SALEITEMS;?></td>
      </tr>
      <tr>
        <th><?php echo _TR_TOTREV;?></th>
        <td><?php echo $core->formatMoney($monthly['totalprice']);?></td>
      </tr>
      <tr>
        <th><?php echo _TR_AVERAGE;?></th>
        <td><?php echo $core->formatMoney($monthly['totalprice']/$monthly['total']);?></td>
      </tr>
    </table>
    <?php endif;?>
  </div>
</div>
<?php break;?>
<?php default: ?>
<?php
  $search = (isset($_POST['search'])) ? intval($_POST['search']) : false;
  $payrow = $member->getPayments($search);
?>
<div class="block-top-header">
  <h1><img src="images/trans-sml.png" alt="" /><?php echo _TR_TITLE1;?></h1>
  <div class="divider"><span></span></div>
</div>
<p class="info"><span><?php echo $core->langIcon();?></span><?php echo _TR_INFO1;?></p>
<div class="block-border">
  <div class="block-header">
    <h2><span><a href="ajax.php?exportTransactions" title="<?php echo _TR_EXPORTXLS;?>" class="tooltip"><img src="images/xls.png" alt="" /></a> <a href="index.php?do=transactions&amp;action=salesyear" title="<?php echo _TR_VIEW_REPORT;?>" class="tooltip"><img src="images/chart.png" alt=""/></a></span><?php echo _TR_SUBTITLE1;?></h2>
  </div>
  <div class="block-content">
    <div class="utility">
      <table class="display">
        <tr>
          <td><form action="#" method="post">
              <input name="search" type="text" class="inputbox" id="search-input" size="40"/>
              <input name="submit" type="submit" class="button-blue" value="<?php echo _TR_FIND;?>" />
            </form></td>
          <td><form action="#" method="post" id="dForm">
              <strong> <?php echo _TR_SHOW_FROM;?> </strong>
              <input name="fromdate" type="text" style="margin-right:3px" class="inputbox-sml" size="12" id="fromdate" />
              <strong> <?php echo _TR_SHOW_TO;?> </strong>
              <input name="enddate" type="text" style="margin-right:3px" class="inputbox-sml" size="12" id="enddate" />
              <input name="find" type="submit" class="button-blue" value="<?php echo _TR_FIND;?>" />
            </form></td>
        </tr>
        <tr>
          <td colspan="2" class="right"><?php echo $pager->items_per_page();?>&nbsp;&nbsp;<?php echo $pager->jump_menu();?></td>
        </tr>
      </table>
    </div>
    <table class="display sortable-table">
      <thead>
        <tr>
          <th class="firstrow">#</th>
          <th class="left sortable"><?php echo _TR_MEMNAME;?></th>
          <th class="left sortable"><?php echo _TR_USERNAME;?></th>
          <th class="left sortable"><?php echo _TR_AMOUNT;?></th>
          <th class="left sortable"><?php echo _TR_PAYDATE;?></th>
          <th class="center"><?php echo _TR_PROCESSOR;?></th>
          <th class="center"><?php echo _TR_STATUS;?></th>
          <th class="center"><?php echo _DELETE;?></th>
        </tr>
      </thead>
      <?php if($pager->display_pages()):?>
      <tfoot>
        <tr>
          <td colspan="8"><div class="pagination"><?php echo $pager->display_pages();?></div></td>
        </tr>
      </tfoot>
      <?php endif;?>
      <tbody>
        <?php if($payrow == 0):?>
        <tr>
          <td colspan="8"><?php echo $core->msgAlert(_TR_NOTRANS,false);?></td>
        </tr>
        <?php else:?>
        <?php foreach ($payrow as $row):?>
        <?php $image = ($row['status'] == 0) ? "pending":"completed";?>
        <?php $status = ($row['status'] == 0) ? 1:0;?>
        <tr>
          <th><?php echo $row['id'];?>.</th>
          <td><?php echo $row['title'];?></td>
          <td><?php echo $row['username'];?></td>
          <td><?php echo $core->formatMoney($row['rate_amount']);?></td>
          <td><?php echo dodate($core->short_date, $row['created']);?></td>
          <td class="center"><img src="images/<?php echo $row['pp'];?>.png" alt="" class="tooltip" title="<?php echo $row['pp'];?>"/></td>
          <td class="center"><img src="images/<?php echo $image;?>.png" alt="" class="tooltip" title="Status: <?php echo ucfirst($image);?>"/></td>
          <td class="center"><a href="javascript:void(0);" class="delete" data-title="<?php echo $row['created'];?>" id="item_<?php echo $row['id'];?>"><img src="images/delete.png" class="tooltip"  alt="" title="<?php echo _DELETE;?>"/></a></td>
        </tr>
        <?php endforeach;?>
        <?php unset($row);?>
        <?php endif;?>
      </tbody>
    </table>
  </div>
</div>
<?php echo Core::doDelete(_DELETE.' '._TRANSACTION, "deleteTransaction");?> 
<script type="text/javascript"> 
// <![CDATA[
$(document).ready(function () {
	$("#search-input").watermark("<?php echo _TR_FINDPAY;?>");
    $(".sortable-table").tablesorter({
        headers: {
            0: {
                sorter: false
            },
            5: {
                sorter: false
            },
            6: {
                sorter: false
            },
            7: {
                sorter: false
            }
        }
    });
});
$(function() {
	var dates = $('#fromdate, #enddate').datepicker({
		defaultDate: "+1w",
		changeMonth: false,
		numberOfMonths: 2,
		dateFormat: 'yy-mm-dd',
		onSelect: function(selectedDate) {
			var option = this.id == "fromdate" ? "minDate" : "maxDate";
			var instance = $(this).data("datepicker");
			var date = $.datepicker.parseDate(instance.settings.dateFormat || $.datepicker._defaults.dateFormat, selectedDate, instance.settings);
			dates.not(this).datepicker("option", option, date);
		}
	});
});
// ]]>
</script>
<?php break;?>
<?php endswitch;?>